#ifndef CCAPTEURDIST_VL53L0X_H
#define CCAPTEURDIST_VL53L0X_H

#include <QObject>
#include <QThread>
#include "VL53L0X.hpp"
#include "VL53L0X_defines.hpp"
#include "global.h"
#include "ci2c.h"
#include "csharedmemory.h"

class CCapteurDist_VL53L0X : public QThread
{
  Q_OBJECT

public:
  explicit CCapteurDist_VL53L0X(QObject *mParent = 0, int noMesBase = 1);
  ~CCapteurDist_VL53L0X();
  bool m_fin;
  float lireMesureDist();

private:
  VL53L0X sensor;
  CSharedMemory *mShm;
  CI2c *mI2c;
  int m_noMesBase;
  unsigned char *mAddr;
  void run();


signals:
  void sigErreur(QString mess);

public slots:
  void onErreur(QString mess);
};

#endif // CCAPTEURDIST_VL53L0X_H
