#include "ccapteurhum_SI7021_A20.h"

CCapteurHum_SI7021_A20::CCapteurHum_SI7021_A20(QObject *mParent) : QThread(mParent)
{
  int file;
  unsigned char init[] = {0x40};
  mi2c = CI2c::getInstance(this, '2');
  if(mi2c == NULL)
    qDebug("Le Capteur a un problème avec init I2C");

  /*mShm = new QSharedMemory(KEY, this);
  if(!mShm->attach())
    qDebug(mShm->errorString().toStdString().c_str());
  mData = (T_Mes *)mShm->data();*/
}

CCapteurHum_SI7021_A20::~CCapteurHum_SI7021_A20()
{
  mi2c->freeInstance();
 // mShm->detach();
 // delete mShm;
}

void CCapteurHum_SI7021_A20::run()
{
  float mesure;

  mArret = false;
  mStopped = false;
  while(!mArret){
      mesure = lireMesure();
      char chMes[30];
      sprintf(chMes, "Mesure du Capteur, humidité:%3.1f", mesure);
      mShm->lock();
 //     strcpy(mData[mNum].valMes,chMes);
      mShm->unlock();
      sleep(1);
    }
  mStopped=true;
}

float CCapteurHum_SI7021_A20::lireMesure()
{
  float hum;
  unsigned char ecriture[0x40];
  unsigned char lecture[2];
  char aff[500];
  int res;
  res = mi2c->ecrire(0x40, ecriture, 1);
  usleep(50000);
  res = mi2c->lire(0x40, lecture, 2);
  if(res != 2)
    qDebug() << "Résultat du Capteur, res=" << res;
  unsigned char MSB = lecture[0];
  unsigned char LSB = lecture[1];
  hum = -6+125*(MSB*256+LSB)/65536;
  sprintf(aff, "Résultats du Capteur, res=%d msb=%02X lsb=%02X hum:%3.1f",res,MSB,LSB,hum);
  return hum;
}

void CCapteurHum_SI7021_A20::stop()
{
  mArret = true;
  while(!mStopped);
}
