#include "ccommuniquer.h"

CCommuniquer::CCommuniquer(QWidget *parent, QString nomport) : QObject(parent)
{
    QStringList stringList;
    QList<QSerialPortInfo> spi;
    spi = QSerialPortInfo::availablePorts();

    for(int i=0; i<spi.size();i++)
    {
        QString str = spi.at(i).portName();
        stringList.append(str);
    }
    mProto = new CProtocole(this, nomport);
    connect(mProto, SIGNAL(sigReponse(QString)), this, SLOT(onReponse(QString)));
}

CCommuniquer::~CCommuniquer()
{
    delete mProto;
    delete mSp;
}

void CCommuniquer::onError(QSerialPort::SerialPortError err)
{
    qDebug() << "ERREUR: " << err;
    QMessageBox msgErr;
    msgErr.setText("Erreur sur la voie série !");
    msgErr.setInformativeText("Veuillez verifier le port.");
    msgErr.setStandardButtons(QMessageBox::Ok);
    msgErr.setDefaultButton(QMessageBox::Ok);
    msgErr.exec();
}



void CCommuniquer::onReponse(QString rep)
{
    emit sigReponse(rep);
}

///////////////////////// AVANT MISSION /////////////////////////

int CCommuniquer::debutMission()
{
    mProto->debutMission();
    return 0;
}

bool CCommuniquer::envoiDonneesConfig(QByteArray qbaTrame)
{
    mProto->envoiDonneesConfig(qbaTrame);
    return true;
}

int CCommuniquer::envoiParamsCapteur(QByteArray qbaTrame)
{
    mProto->envoiParamsCapteur(qbaTrame);
    return 0;
}

int CCommuniquer::miseAHeureEDD(QByteArray qbaTrame)
{
    mProto->miseAHeureEDD(qbaTrame);
    return 0;
}

int CCommuniquer::testComm()
{
    mProto->testComm();
    return 0;
}

////////////////////////// PENDANT MISSION /////////////////////////

int CCommuniquer::debutAcquisition(QByteArray qbaTrame)
{
    mProto->debutAcquisition(qbaTrame);
    return 0;
}

int CCommuniquer::stopAcquisition(QByteArray qbaTrame)
{
    mProto->stopAcquisition(qbaTrame);
    return 0;
}

int CCommuniquer::camera(QByteArray qbaTrame)
{
    mProto->camera(qbaTrame);
    return 0;
}

int CCommuniquer::modifParamIncruste(QByteArray qbaTrame)
{
    mProto->modifParamIncruste(qbaTrame);
    return 0;
}

int CCommuniquer::mesuresInstantane(QByteArray qbaTrame)
{
    mProto->mesuresInstantane(qbaTrame);
    return 0;
}
